<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <title>Installation</title>

    <link rel="stylesheet" href="/en/latestcss/core.css">
    <link rel="stylesheet" href="/en/latestcss/getstarted.css">
    <link rel="shortcut icon" href="/en/latestcss/images/saltStack_favIcon_32x32.png">

</head>
<body>

<nav id="globalNavbar" class="navbar navbar-default navbar-inverse navbar-fixed-top" role="navigation">
    <!-- Brand and toggle get grouped for better mobile display -->
    <div class="container">
        <div class="navbar-header">
            <button type="button" class="navbar-toggle" data-toggle="collapse" data-target="#navbarCollapse">
                <span class="sr-only">Toggle navigation</span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
            </button>
            <a href="http://saltstack.com/" target="_blank"><img src="/en/latestcss/images/saltstack.svg" height="40px" width="170px" class="nolightbox"></a>
        </div>
        <!-- Collect the nav links, forms, and other content for toggling -->
        <div class="collapse navbar-collapse" id="navbarCollapse">
            <ul class="nav navbar-nav">
                <li><a href="/en/latest">Documentation</a></li>
                <li><a href="/en/getstarted/">Tutorials</a></li>
                <li><a href="/en/latestcontents.html">Reference Guide</a></li>
                <li><a href="https://repo.saltstack.com">Downloads</a></li>
                <li><a href="/en/latesttopics/development/">Develop</a></li>
            </ul>
        </div>
    </div>
</nav>

<div class="jumbotron">

    <div class="row row-centered">
        <div class="col-md-9 col-centered">
            <h1>Salt Cloud</h1>

            <h3>Get Started Tutorial</h3>

        </div>
    </div>
    <!--<div class="gs-top-nav">
        <a href="/en/getstarted/getstarted/index.html">Back to Get Started <i class="glyphicon glyphicon-arrow-left"></i></a><br>
        <a href="/en/getstarted">Back to Documentation <i class="glyphicon glyphicon-arrow-left"></i></a>
    </div>-->
</div>







<div class="container">
    <div class="row">
        <div class="col-md-12">
            <ol class="progtrckr" data-progtrckr-steps="7">
                
                
                
                <li class="progtrckr-done">
                    
                    <a href="/en/getstarted/cloud/index.html">Salt Cloud</a>
                </li>
                
                
                
                
                <li class="progtrckr-done">
                    
                    <a href="/en/getstarted/cloud/account.html">Cloud Account</a>
                </li>
                
                
                
                <li class="progtrckr-done">Installation</li>
                
                
                
                
                
                
                
                
                
                
                
                
                
                <li class="progtrckr-todo">
                    
                    <a href="/en/getstarted/cloud/provider.html">Salt Cloud Provider</a>
                </li>
                
                
                
                
                <li class="progtrckr-todo">
                    
                    <a href="/en/getstarted/cloud/profile.html">Salt Cloud Profile</a>
                </li>
                
                
                
                
                <li class="progtrckr-todo">
                    
                    <a href="/en/getstarted/cloud/map.html">Salt Cloud Map</a>
                </li>
                
                
                
                
                <li class="progtrckr-todo">
                    
                    <a href="/en/getstarted/cloud/vm.html">Salt Cloud VMs</a>
                </li>
                
                
            </ol>
        </div>
    </div>

    <div class="row">
        <div class="col-md-1"></div>
        <div class="col-md-10">

            

            <h1>Installation</h1>

            <div class="section gs-overview">

                
                <p class="p gs-overview-sub"><span class="ph">You'll learn how to:</span></p>

                <ul class="ul">
                    
                    <li class="progtrckr-done">Goal</li>
                    
                    <li class="progtrckr-done">Goal</li>
                    
                </ul>
                

                
                <p class="p gs-overview-sub gs-time"><span class="ph">
                              Estimated time: 10 minutes</span>&nbsp;<i
                        class="glyphicon glyphicon-time"></i>
                </p>
                

                
                <p class="p gs-overview-sub gs-difficulty-1"><span class="ph">Difficulty</span>:&nbsp;
                    
                    
                    <i class="glyphicon glyphicon-cog"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                </p>
                
            </div>
            

            <p>Now that we have an account on a cloud provider, we need to set up a system to run Salt Cloud. You can run Salt Cloud from an existing Salt master, or you can set up a dedicated system.</p>
<p>Note that cloud VMs do not have to be managed by the Salt Cloud system that creates them, you can specify any server as the Salt master.</p>
<h2 id="demo-system">Demo System</h2>
<p>You can use any Salt master or other Linux system where you can install packages to test Salt cloud. If you have <a href="https://www.vagrantup.com/">Vagrant</a> and <a href="https://www.virtualbox.org/wiki/Downloads">VirtualBox</a> installed, you can use the following Vagrantfile to quickly set up a demo environment:</p>
<pre class="language-ruby"><code class="language-ruby"><span class="co"># -*- mode: ruby -*-</span>
<span class="co"># vi: set ft=ruby :</span>

<span class="co"># Vagrantfile API/syntax version. Don&#39;t touch unless you know what you&#39;re doing!</span>
<span class="dt">VAGRANTFILE_API_VERSION</span> = <span class="st">&quot;2&quot;</span>

<span class="dt">Vagrant</span>.configure(<span class="dt">VAGRANTFILE_API_VERSION</span>) <span class="kw">do</span> |config|
  config.vm.define <span class="st">:master</span> <span class="kw">do</span> |master_config|
    master_config.vm.box = <span class="st">&quot;ubuntu/trusty64&quot;</span>
    master_config.vm.host_name = <span class="st">&#39;saltcloud.local&#39;</span>
    master_config.vm.network <span class="st">&quot;private_network&quot;</span>, ip: <span class="st">&quot;192.168.90.10&quot;</span>
    master_config.vm.synced_folder <span class="st">&quot;salt/&quot;</span>, <span class="st">&quot;/etc/salt/&quot;</span>
  <span class="kw">end</span>
<span class="kw">end</span></code></pre>
<p>Save this file as <code>Vagrantfile</code> in any directory on your system. In that same directory, create a <code>salt</code> sub-directory. This directory is synced with the <code>/etc/salt/</code> directory on the VM to make it easy to migrate key files and cloud configuration files.</p>
<p>This uses the same base image as the <a href="../fundamentals/">Demo Environment</a> from the <em>SaltStack Fundamentals</em> guide, so if you have completed that guide this might save you some bandwidth.</p>
<p>Run <code>vagrant up</code> and then <code>vagrant ssh master</code> to connect to the demo system.</p>
<h2 id="key-file">Key File</h2>
<p>Copy the JSON private key file for your GCE service account to the <code>salt</code> synced folder you created above, and then from the terminal set owner read permissions on this file (<code>sudo chmod 0400 /etc/salt/*.json</code>).</p>
<h2 id="install-salt-and-salt-cloud">Install Salt and Salt Cloud</h2>
<p>We’ll use the SaltStack official repository to install packages, and then install the latest stable version of <code>apache-libcloud</code>.</p>
<ol>
<li><p>Run the following command to import the SaltStack repository key:</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">wget</span> -O - https://repo.saltstack.com/apt/ubuntu/14.04/amd64/latest/SALTSTACK-GPG-KEY.pub <span class="kw">|</span> <span class="kw">sudo</span> apt-key add -</code></pre></li>
<li><p>Add the following line to <code>/etc/apt/sources.list</code>:</p>
<pre class="language-ini"><code class="language-ini"><span class="dt">deb http://repo.saltstack.com/apt/ubuntu/14.04/amd64/latest trusty main</span></code></pre></li>
<li><p>Run <code>sudo apt-get update</code></p></li>
<li><p>Install the Salt master and Salt Cloud:</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">`sudo</span> apt-get install salt-master salt-cloud<span class="kw">`</span></code></pre></li>
<li><p>Install pip:</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">sudo</span> apt-get install python-pip</code></pre></li>
<li><p>Install the latest stable version of apache-libcloud (0.20.1):</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">sudo</span> pip install apache-libcloud==0.20.1</code></pre></li>
</ol>
<p>Your system is now ready to run Salt Cloud.</p>


            <br>
            
            <a href="/en/getstarted/cloud/account.html">
                <button type="button" class="btn btn-secondary"><span
                        class="glyphicon glyphicon-chevron-left"></span> Previous
                </button>
            </a>
            

            
            <a href="/en/getstarted/cloud/provider.html">
                <button type="button" class="btn btn-primary btn-right">
                    Next <span class="glyphicon glyphicon-chevron-right"></span></button>
            </a>
            

        </div>
        <div class="col-md-1"></div>
    </div>
    <div class="footer">
    <p>© 2020 SaltStack | <a href="http://saltstack.com/privacy-policy" target="_blank">Privacy Policy</a></p>
</div>
</div>

<script type="text/javascript" src="/en/latestjs/core-min.js"></script>



<!--analytics-->
<script type="text/javascript" language="javascript">llactid=23943</script>
<script type="text/javascript" language="javascript" src="https://trackalyzer.com/trackalyze_secure.js"></script>

<script>
          var _gaq = _gaq || [];
          var pluginUrl = '//www.google-analytics.com/plugins/ga/inpage_linkid.js';
          _gaq.push(['_require', 'inpage_linkid', pluginUrl]);
          _gaq.push(['_setAccount', 'UA-26984928-1']);
          _gaq.push(['_setDomainName', 'saltstack.com']);
          _gaq.push(['_trackPageview']);

          (function() {
              var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
              ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
              var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
          })();

</script>

</body>
</html>